﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
namespace Demo
{
  class Program
  {
    static void Main(string[] args)
    {
      try
      {
        Console.WriteLine("\nBegin Diffusion Testing demo\n");
        Console.WriteLine("Method under test: Choose(n,k)\n");
        //long eightChooseThree = Choose(8, 3);
        //Console.WriteLine(eightChooseThree);
        string[] testCases = new string[] { "001:8:3:56", "002:7:5:20", "003:9:2:36" };
        foreach (string currTestCase in testCases)
        {
          string result = ProcessTestCase(currTestCase);
          if (result == "pass")
          {
            Console.WriteLine("Automatically creating new test case");
            string newTestCase = CreateDiffusedTestCase(currTestCase);
            //Console.WriteLine("diff tc = " + diffusedTestCase);
            ProcessTestCase(newTestCase);
          }
        }
        Console.WriteLine("===========================");
        Console.WriteLine("\nEnd demo\n");
        Console.ReadLine();
      }
      catch (Exception ex)
      {
        Console.WriteLine("Fatal: " + ex.Message);
        Console.ReadLine();
      }
    } // Main()
    static long Choose(int n, int k)
    {
      long delta, iMax;
      if (k < n - k) { delta = n - k; iMax = k; }
      else { delta = k; iMax = n - k; }
      long answer = delta + 1;
      for (long i = 2; i <= iMax; ++i)
        checked { answer = (answer * (delta + i)) / i; }
      return answer;
    }
    static string ProcessTestCase(string testCase)
    {
      string[] tokens = testCase.Split(':');
      string caseID = tokens[0];
      int n = int.Parse(tokens[1]);
      int k = int.Parse(tokens[2]);
      long expected = long.Parse(tokens[3]);
      Console.WriteLine("===========================");
      Console.WriteLine("Case ID = " + caseID);
      Console.WriteLine("n = " + n + " k = " + k);
      Console.Write("Expected result = " + expected);
      long actual = Choose(n, k);
      Console.WriteLine(" Actual = " + actual);
      if (actual == expected) { Console.WriteLine("Pass"); return "pass"; }
      else { Console.WriteLine("** Fail ** "); return "fail"; }
    }
    static string CreateDiffusedTestCase(string existingTestCase)
    {
      string[] tokens = existingTestCase.Split(':');
      string oldTestCase = tokens[0];
      int oldN = int.Parse(tokens[1]);
      int oldK = int.Parse(tokens[2]);
      long oldExpected = long.Parse(tokens[3]);
      string newTestCase = oldTestCase + "-diffused";
      int newN = oldN + 1;
      int newK = oldK;
      //long newExpected = oldExpected * ((oldN + 1) / (oldN - oldK + 1));
      long newExpected = (oldExpected * (oldN + 1)) / (oldN - oldK + 1);
      //Console.WriteLine("new expected = " + newExpected);
      return newTestCase + ":" + newN + ":" + newK + ":" + newExpected;
    }
  } // Program
} // ns
